<?php
/**
 * Bases de datos 2 - funciones.php
 * 
 * @author    Bartolomé Sintes Marco <bartolome.sintes+mclibre@gmail.com>
 * @copyright 2011 Bartolomé Sintes Marco
 * @license   http://www.gnu.org/licenses/agpl.txt AGPL 3 or later
 * @version   2011-04-14
 * @link      http://www.mclibre.org
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

define('FORM_METHOD',            'get');  // Formularios se envían con GET
//define('FORM_METHOD',            'post'); // Formularios se envían con POST
define('MENU_1', 1);   // Menú principal 
define('MENU_2', 2);   // Menú Volver a inicio   
define('MYSQL',          'MySQL');
define('SQLITE',         'SQLite');
define('TAM_NOMBRE',     40);  // Tamaño del campo Nombre
define('TAM_APELLIDOS',  60);  // Tamaño del campo Apellidos
define('MAX_REG_AGENDA', 20);  // Número máximo de registros en la tabla Agenda

$dbMotor = SQLITE;                    // Base de datos empleada
if ($dbMotor==MYSQL) {
    define('MYSQL_HOST', 'mysql:host=localhost'); // Nombre de host MYSQL
    define('MYSQL_USUARIO', 'root');  // Nombre de usuario de MySQL 
    define('MYSQL_PASSWORD', '');     // Contraseña de usuario de MySQL
    $dbDb     = 'mclibre_base_datos_2';     // Nombre de la base de datos
    $dbTabla = $dbDb.'.tabla';      // Nombre de la tabla
} elseif ($dbMotor==SQLITE) {
    $dbDb    = '/tmp/mclibre/mclibre_base_datos_2.sqlite';  // Nombre de la base de datos
    $dbTabla = 'tabla';             // Nombre de la tabla
}

$recorta = array(
    'nombre'    => TAM_NOMBRE, 
    'apellidos' => TAM_APELLIDOS);

function conectaDb()
{
    global $dbMotor, $dbDb;
    
    try {
        if ($dbMotor==MYSQL) {
            $db = new PDO(MYSQL_HOST, MYSQL_USUARIO, MYSQL_PASSWORD);
            $db->setAttribute(PDO::MYSQL_ATTR_USE_BUFFERED_QUERY, TRUE);
        } elseif ($dbMotor==SQLITE) {
            $db = new PDO('sqlite:'.$dbDb);
        }
        return($db);
    } catch (PDOException $e) {
        cabecera('Error grave', MENU_1);
        print "<p>Error: No puede conectarse con la base de datos.</p>\n";
        print "<p>Error: " . $e->getMessage() . "</p>\n";
        pie();
        exit();
    }
}

function recorta($campo, $cadena)
{
    global $recorta;

    $tmp = isset($recorta[$campo]) ? substr($cadena, 0, $recorta[$campo]) : $cadena; 
    return $tmp;
}

function recogeParaConsulta($db, $var, $var2='') 
{
    $tmp = (isset($_REQUEST[$var]) && ($_REQUEST[$var]!='')) ?
        trim(strip_tags($_REQUEST[$var])) : trim(strip_tags($var2));
    if (get_magic_quotes_gpc()) {
        $tmp = stripslashes($tmp);
    }
    $tmp = str_replace('&', '&amp;',  $tmp);
    $tmp = str_replace('"', '&quot;', $tmp);
    $tmp = recorta($var, $tmp);
    if (!is_numeric($tmp)) {
        $tmp = $db->quote($tmp);
    }
    return $tmp;
}

function cabecera($texto, $menu) 
{
    print "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">
<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"
       \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">
<html xmlns=\"http://www.w3.org/1999/xhtml\">
<head>
  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\" />
  <title>www.mclibre.org - Bases de datos 2 - $texto</title>
  <link href=\"mclibre_php_soluciones_proyectos_comun.css\" rel=\"stylesheet\" type=\"text/css\" />
</head>

<body>
<h1>Bases de datos 2 - $texto</h1>
<div id=\"menu\">
  <ul>\n";
    if ($menu==MENU_1) {
    	print "    <li><a href=\"anyadir1.php\">Añadir registro</a></li>
    <li><a href=\"borrartodo1.php\">Borrar todo</a></li>\n";
    } else {
        print "    <li><a href=\"index.php\">Página inicial</a></li>\n";
    }
    print "  </ul>  
</div>\n\n<div id=\"contenido\">\n";
}

function pie() 
{
    print '</div>

<div id="pie">
<address>
  Este programa forma parte del curso "Páginas web con PHP" disponible en <a
  href="http://www.mclibre.org/">http://www.mclibre.org</a><br />
  Autor: Bartolomé Sintes Marco<br />
  Última modificación de este programa: 14 de abril de 2011
</address>
<p class="licencia">El programa PHP que genera esta página está bajo 
<a rel="license" href="http://www.gnu.org/licenses/agpl.txt">licencia AGPL 3 o
posterior</a>.</p>
</div>
</body>
</html>';
}
